# GET /refund/{{customer_id}} — List All Refund By Customer Id

> Product: **Pabbly Subscription Billing** (v1)
> Base URL: `https://payments.pabbly.com/api/v1`
> Auth: Basic via `Authorization` header
> Canonical: `/subscription-billing/payment-transaction/list-all-refund-by-customer-id`

This API is used to retrieve a list of all the available refunds by customer id.

**Path parameters:**

| Name | Type | Required | Description |
|------|------|----------|-------------|
| customer_id | string | Yes |  |

**Query parameters:**

| Name | Type | Required | Description |
|------|------|----------|-------------|
| limit | string | No | Integer, default=50, min=1, max=100 The number of resources to be returned. |
| page | string | No | By default first page will be listed. For navigating through pages, use the page parameter. |
| invoice_id | string | No | Uniquely identifies the invoice. It is the api identifier for the invoice. |
| subscription_id | string | No | Uniquely identifies the subscription. It is the api identifier for the subscription. |
| product_id | string | No | Uniquely identifies the product. It is the api identifier for the product. |
| plan_id | string | No | Uniquely identifies the plan. It is the api identifier for the plan. |
| status | string | No | Supported value: success, failure, created, paid, inprogress etc |

**Response (200)** — List All Refund By Customer Id:

```json
{
    "status": "success",
    "message": "Refund data",
    "data": [
        {
            "subscription_id": "5e5f364c3b2518365c7923bf",
            "plan_id": "5e3bf8b8db85462760295d2f",
            "product_id": "5e3a95143c92e44b424b6d47",
            "type_formated": "Refund",
            "status_formatted": "Success",
            "reference_id": "5e5f364c3b2518365c7923c5",
            "gateway_type": "test",
            "createdAt": "2020-03-04T07:01:13.646Z",
            "updatedAt": "2020-03-04T07:01:13.646Z",
            "id": "5e5f52393b2518365c792435",
            "customer_id": "5e5f364c3b2518365c7923be",
            "invoice_id": "5e5f364c3b2518365c7923c0",
            "type": "refund",
            "status": "success",
            "reference_number": "",
            "amount": 150,
            "description": "Partial refund as agreed with  the sales team."
        }
    ]
}
```

**Code examples:**

_cURL_

```curl
curl https://payments.pabbly.com/api/v1/refund/{{customer_id}}?limit={{limit}}&page={{page}}&invoice_id={{invoice_id}}&subscription_id={{subscription_id}}&product_id={{product_id}}&plan_id={{plan_id}}&status={{status}} \
  -u {{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}
```

_Ruby_

```ruby
require 'net/http'
require 'json'

uri = URI('https://payments.pabbly.com/api/v1/refund/{{customer_id}}?limit={{limit}}&page={{page}}&invoice_id={{invoice_id}}&subscription_id={{subscription_id}}&product_id={{product_id}}&plan_id={{plan_id}}&status={{status}}')
request = Net::HTTP::Get.new(uri)
request.basic_auth '{{YOUR_API_KEY}}', '{{YOUR_SECRET_KEY}}'

response = Net::HTTP.start(uri.hostname, uri.port, use_ssl: uri.scheme == 'https') do |http|
  http.request(request)
end

data = JSON.parse(response.body)
```

_Python_

```python
import requests
from requests.auth import HTTPBasicAuth

response = requests.get(
    'https://payments.pabbly.com/api/v1/refund/{{customer_id}}?limit={{limit}}&page={{page}}&invoice_id={{invoice_id}}&subscription_id={{subscription_id}}&product_id={{product_id}}&plan_id={{plan_id}}&status={{status}}',
    auth=HTTPBasicAuth('{{YOUR_API_KEY}}', '{{YOUR_SECRET_KEY}}'),
)

data = response.json()
```

_PHP_

```php
<?php
$ch = curl_init('https://payments.pabbly.com/api/v1/refund/{{customer_id}}?limit={{limit}}&page={{page}}&invoice_id={{invoice_id}}&subscription_id={{subscription_id}}&product_id={{product_id}}&plan_id={{plan_id}}&status={{status}}');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_USERPWD, '{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}');

$response = curl_exec($ch);
curl_close($ch);
$data = json_decode($response, true);
```

_Java_

```java
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.util.Base64;

String credentials = Base64.getEncoder().encodeToString("{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}".getBytes());

HttpClient client = HttpClient.newHttpClient();
HttpRequest.Builder builder = HttpRequest.newBuilder()
    .uri(URI.create("https://payments.pabbly.com/api/v1/refund/{{customer_id}}?limit={{limit}}&page={{page}}&invoice_id={{invoice_id}}&subscription_id={{subscription_id}}&product_id={{product_id}}&plan_id={{plan_id}}&status={{status}}"))
    .header("Authorization", "Basic " + credentials)
    .GET();

HttpRequest request = builder.build();
HttpResponse<String> response = client.send(request, HttpResponse.BodyHandlers.ofString());
System.out.println(response.body());
```

_Node.js_

```node
const credentials = Buffer.from('{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}').toString('base64');

const response = await fetch('https://payments.pabbly.com/api/v1/refund/{{customer_id}}?limit={{limit}}&page={{page}}&invoice_id={{invoice_id}}&subscription_id={{subscription_id}}&product_id={{product_id}}&plan_id={{plan_id}}&status={{status}}', {
  method: 'GET',
  headers: {
    'Authorization': `Basic ${credentials}`,
  },
});

const data = await response.json();
```

_Go_

```go
package main

import (
    "fmt"
    "io"
    "net/http"
)

func main() {
    req, _ := http.NewRequest("GET", "https://payments.pabbly.com/api/v1/refund/{{customer_id}}?limit={{limit}}&page={{page}}&invoice_id={{invoice_id}}&subscription_id={{subscription_id}}&product_id={{product_id}}&plan_id={{plan_id}}&status={{status}}", nil)
    req.SetBasicAuth("{{YOUR_API_KEY}}", "{{YOUR_SECRET_KEY}}")

    res, _ := http.DefaultClient.Do(req)
    defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)
    fmt.Println(string(body))
}
```

_.NET_

```dotnet
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

var credentials = Convert.ToBase64String(Encoding.ASCII.GetBytes("{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}"));

var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Get, "https://payments.pabbly.com/api/v1/refund/{{customer_id}}?limit={{limit}}&page={{page}}&invoice_id={{invoice_id}}&subscription_id={{subscription_id}}&product_id={{product_id}}&plan_id={{plan_id}}&status={{status}}");
request.Headers.TryAddWithoutValidation("Authorization", $"Basic {credentials}");

var response = await client.SendAsync(request);
var data = await response.Content.ReadAsStringAsync();
Console.WriteLine(data);
```

---

**Other endpoints in Payment/Transaction:**

- [GET /transactions/{{customer_id}} — List All Transactions By Customer Id](/subscription-billing/payment-transaction/list-all-transactions-by-customer-id)
- [DELETE /transaction/{{transaction_id}} — Delete Transaction](/subscription-billing/payment-transaction/delete-transaction)
- [POST /transaction/refund/{{payment_id}} — Payment Refund](/subscription-billing/payment-transaction/payment-refund)
- [POST /transaction/refund/{{payment_id}} — Record Refund](/subscription-billing/payment-transaction/record-refund)

